import processing.serial.*;

Serial myPort;
int bytes = 0;
char inByte;

byte buttons[];

void setup() {
    // Pull in button data as an array
    buttons =  loadBytes("klmz3-smb.txt");
    
    // Connect to the arduino through the first COM port available
    println(Serial.list());
    myPort = new Serial(this, Serial.list()[0], 115200);
    
    // Wait for a little dummy data before sending the actual data
    while (inByte != '0')
    {
        while (myPort.available() > 0) {
            bytes++;
            inByte = myPort.readChar();
            print('|');
            print(inByte);
            println('|');
        }
    }
    
    // If the arduino does not send a 0, the SD card failed to be ready
    if (inByte != '0')
    {
        println("SD initializaion failed");
        exit();
    }
    
    // First send the length of the movie  
    myPort.write(Integer.toString(buttons.length));
    println(buttons.length);
    myPort.write(' ');
    
    // Write the button data
    for (long i = 0; i < buttons.length; i++) {
        if (i % 1000 == 0) { println(i); }
        
        myPort.write(buttons[(int)i]);
    }
} 

// Movie is now uploaded!

void draw() {
    while (myPort.available() > 0) {
      char inByte = myPort.readChar();
      print(inByte);
    }
}
